<?php
/**
 * @copyright	Copyright (C) 2014 Holest Engineering www.holest.com.
 * @license		GNU General Public License version 2 or later
 */
 
defined('_JEXEC') or die('Restricted Access not allowed');
if(!defined('DS'))
	define('DS', DIRECTORY_SEPARATOR );

function getCurrentTS(){
	return round(microtime(true) * 1000);
}

if(!function_exists('sanitize_text_field')){
	function sanitize_text_field($str){
		return $str;
	}
}

if(!function_exists("sc_read_sanitized_get_parm")){
   function sc_read_sanitized_get_parm($parm_name, $default = NULL){
	    global $sc_raw_get;
		if(!isset($sc_raw_get)){
			$sc_raw_get = JFactory::getApplication()->input->get->getArray();
		}
		
		if(isset($sc_raw_get[$parm_name])){
			if(is_array($sc_raw_get[$parm_name])){
				foreach($sc_raw_get[$parm_name] as $index => $value){
					$sc_raw_get[$parm_name][$index] = sanitize_text_field($value);
				}
				return $sc_raw_get[$parm_name];
			}else
				return sanitize_text_field($sc_raw_get[$parm_name]);
		}
		return $default;
   }	
}

if(!function_exists("sc_read_sanitized_request_parm")){
   function sc_read_sanitized_request_parm($parm_name, $default = NULL){
	    global $sc_raw_request;
		if(!isset($sc_raw_request)){
			$sc_raw_request = array_merge(JFactory::getApplication()->input->get->getArray(),JFactory::getApplication()->input->post->getArray());
		}
		if(isset($sc_raw_request[$parm_name])){
			if(is_array($sc_raw_request[$parm_name])){
				foreach($sc_raw_request[$parm_name] as $index => $value){
					$sc_raw_request[$parm_name][$index] = sanitize_text_field($value);
				}
				return $sc_raw_request[$parm_name];
			}else{
				return sanitize_text_field($sc_raw_request[$parm_name]);
			}
		}
		global $sc_query_data;
		if(!isset($sc_query_data)){
			if(sc_read_sanitized_get_parm("scpacked",false)){
				//scpacked may contain semi-sensitive data therefore it must not be sent as plain text!!!
				$strpacked     = base64_decode(sc_read_sanitized_get_parm("scpacked",""));
				$dpos          = strpos($strpacked,"|");
				$ts            = intval(substr($strpacked,0,$dpos));
				$strpacked     = substr($strpacked,$dpos+1);
				$ror           = ($ts % (strlen($strpacked) - 2)) + 1;
				$strpacked     = substr($strpacked,$ror) . substr($strpacked,0,$ror);
				$sc_query_data = json_decode(base64_decode($strpacked),true);
			}else
				$sc_query_data = false;
		}
		if($sc_query_data){
			if(isset($sc_query_data[$parm_name])){
				return $sc_query_data[$parm_name];
			}
		}
		return $default;
   }	
}

if(!function_exists("sc_get_user_param")){
	function sc_get_user_param($sc_site_user_id, $name, $default = null){
		global $db, $sc_user_params;
		
		if(!$db)
			$db = JFactory::getDbo();

		if(!$sc_site_user_id)
			return null;

		if(!isset($sc_user_params)){
			$db->setQuery("SELECT params FROM #__users WHERE id = " . $db->quote($sc_site_user_id));
			$params = json_decode($db->loadResult());
			if($params){
				$sc_user_params = $params;
			}
		}

		if(!$sc_user_params)
			return $default;

		if(!isset($sc_user_params->{$name}))
			return $default;

		return $sc_user_params->{$name};
	}
}

if(!function_exists("sc_user_token")){
	function sc_user_token($sc_site_user_id = null){
		$u = null;
		if($sc_site_user_id === null){
			$sc_site_user_id = sc_read_sanitized_request_parm("luid",null);
			if(!$sc_site_user_id && isset($_SERVER["luid"])){
				$sc_site_user_id = intval($_SERVER["luid"]);
			}
		}
		
		if($sc_site_user_id === null){
			$u = JFactory::getUser();
			if(!$u)
				return null;
			
			if(!$u->id)
				return null;
		}
		
		return sc_get_user_param($sc_site_user_id,"_sc_api_token",null);
	}
}

$ts = getCurrentTS();

if(!function_exists("sc_curlHeadersToArray")){
	function sc_curlHeadersToArray( $str ){
		$headers = array();
		$headersTmpArray = explode("\r\n" , $str);
		for ( $i = 0 ; $i < count( $headersTmpArray ) ; ++$i ){
			if ( strlen( $headersTmpArray[$i] ) > 0 ){
				if ( strpos( $headersTmpArray[$i] , ":" ) ){
					$headerName = substr( $headersTmpArray[$i] , 0 , strpos( $headersTmpArray[$i] , ":" ) );
					$headerValue = substr( $headersTmpArray[$i] , strpos( $headersTmpArray[$i] , ":" )+1 );
					
					if(stripos($headerName,"HTTP_") === 0){
						$headerName = substr($headerName,5);
					}
					
					$headers[strtolower($headerName)] = $headerValue;
				}
			}
		}
		return $headers;
	}
}

if(!function_exists("sellingcommander_local")){
	function sellingcommander_local(){
		
		$protocol = isset($_SERVER['HTTPS']) ? 'https://' : 'http://';
		
		if(sc_read_sanitized_request_parm("consoletest")){
			$url = "{$protocol}sellingcommander.com/consoletest/?consoletest=consoletest";
		}else if(sc_read_sanitized_request_parm("p_shopid")){
			$url = "{$protocol}sellingcommander.com?p_shopid=" . sc_read_sanitized_request_parm("p_shopid");
		}else if(sc_read_sanitized_request_parm("o_shopid")){
			$url = "{$protocol}sellingcommander.com?o_shopid=" . sc_read_sanitized_request_parm("o_shopid");
		}else if(sc_read_sanitized_request_parm("b_shopid")){
			$url = "{$protocol}sellingcommander.com?b_shopid=" . sc_read_sanitized_request_parm("b_shopid");
		}else if(sc_read_sanitized_request_parm("c_shopid")){
			$url = "{$protocol}sellingcommander.com?c_shopid=" . sc_read_sanitized_request_parm("c_shopid");
		}else if(sc_read_sanitized_request_parm("d_shopid")){
			$url = "{$protocol}sellingcommander.com?d_shopid=" . sc_read_sanitized_request_parm("d_shopid");
		}
		
		if(!sc_read_sanitized_request_parm("sc_direct_user_token")){
			header('HTTP/1.0 403 Forbidden');
			echo '403 Forbidden DUT';
			die;
		}
		
		if(!$url){
			die(JText::sprintf("Unknown SC managment scope","sellingcommander"));
			die;
		}
		
		$pass = array(
			"diff"                 => rand(10000,99999)
		);
		
		global $sc_query_data;
		foreach($sc_query_data as $key => $val){
			if($key == "action" && $val == "sellingcommander_local")
				continue;
			$pass[$key] = $val;
		}
		
		foreach(JFactory::getApplication()->input->post->getArray() as $key => $val){
			if($val == "com_sellingcommanderconnector" || ($key == "action" && $val == "sellingcommander_local") || $key == "scpacked")
				continue;
			$pass[$key] = $val;
		}
		
		foreach(JFactory::getApplication()->input->get->getArray() as $key => $val){
			if($val == "com_sellingcommanderconnector" || ($key == "action" && $val == "sellingcommander_local") || $key == "scpacked")
				continue;
			$pass[$key] = $val;
		}
		
		$pass["scinlocal"] = 1;
		
		if(!empty($pass))
			$url .= ("&" . http_build_query($pass));
		
		$ch = curl_init($url);
		
		curl_setopt($ch, CURLOPT_CUSTOMREQUEST,"GET"); 
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_TIMEOUT, 60);
		curl_setopt($ch, CURLOPT_HEADER , true );
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
		
		$response = curl_exec($ch);
		$httpcode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
		
		$headerSize = curl_getinfo($ch , CURLINFO_HEADER_SIZE );
		
		curl_close($ch);
		
		$headerStr = substr( $response , 0 , $headerSize );
		$bodyStr = substr( $response , $headerSize );
		$headers = sc_curlHeadersToArray($headerStr);
		
		if(isset($headers)){
			if(isset($headers["content-type"])){
				header("Content-Type: " . $headers["content-type"]);
			}

			if(isset($headers["luid"])){
				header("luid: " . $headers["luid"]);
			}

			if(isset($headers["sctoken"])){
				header("SCTOKEN: " . $headers["sctoken"]);
			}

			if(isset($headers["scdut"])){
				header("SCDUT: " . $headers["scdut"]);
			}			
		}
		
		if(isset($_SERVER['HTTP_ORIGIN']))
			header('Access-Control-Allow-Origin: ' . $_SERVER['HTTP_ORIGIN']); 
		else{
			header('Access-Control-Allow-Origin: *');	
		}
		
		echo $bodyStr;
		exit(intval($httpcode));
	}
}

if(sc_read_sanitized_request_parm("action") == "scprobe"){
	echo "SC_PROBE_OK";
	die;
}

if(sc_read_sanitized_request_parm("action") == "sellingcommander_local"){
	sellingcommander_local();
}

if(sc_read_sanitized_request_parm("action") == "enterb2b"){
	return;
}else if(sc_read_sanitized_request_parm("sctoken") || ($_SERVER["sctoken"])){
	
	$ob_clean_loop = 0;
	while(ob_get_level()){
		$ob_clean_loop++;
		$obstatus = ob_get_status();
		if(!$obstatus)
			break;
		
		if(stripos($obstatus["name"],"gzhandler") !== false || stripos($obstatus["name"],"gzip"))
			break;
		
		ob_clean();
		if($ob_clean_loop >= 5)
			break;
	}
	
	class ErrorHandler extends Exception {
		protected $severity;
		
		public function __construct($message, $code, $severity, $filename, $lineno) {
			$this->message = $message;
			$this->code = $code;
			$this->severity = $severity;
			$this->file = $filename;
			$this->line = $lineno;
		}
		
		public function getSeverity() {
			return $this->severity;
		}
	}
	
	function sc_error_handler($severity = null, $message = null, $file = null, $line = null, $ctx = null, $arg = null) {
		
		if($severity == E_DEPRECATED || $severity == E_USER_DEPRECATED || $severity == 16384){
			if(!sc_read_sanitized_get_parm("SC_DEBUG",null))
				return;
		}
		
		global $sc_error_log, $sc_error_log_suppress;
		
		if(isset($sc_error_log_suppress)){
			if($sc_error_log_suppress){
				return;
			}
		}
		
		if(!$sc_error_log)
			$sc_error_log = array();
		
		if(!isset($sc_error_log[$severity]))
			$sc_error_log[$severity] = array();
		
		$eerr = new stdClass;
		$eerr->message   = $message;
		$eerr->file      = $file;
		$eerr->line      = $line; 
		
		$sc_error_log[$severity][basename($file). ":{$line}"] = $eerr;
		
		if($severity == E_ERROR || $severity == E_USER_ERROR ){
			global $sc_last_sql_query;
			if(!isset($sc_last_sql_query))
				$sc_last_sql_query = null;
		
			$response = new stdClass;
			$response->error   = "ERROR";
			$response->message = $message;
			$response->file    = $file;
			$response->line    = $line; 
			$response->error_log = $sc_error_log;
			$response->last_sql_query = $sc_last_sql_query;
			$response->backtrace = debug_backtrace(2,5);
			echo json_encode($response);
			die;
			//throw new ErrorHandler($message,$severity,$severity,$file, $line);
		}
	}
	
	function sc_uncaught_exception_handler($exception = null, $arg = null){
			global $sc_error_log;
			global $sc_last_sql_query;
			
			if(!isset($sc_last_sql_query))
				$sc_last_sql_query = null;
			
			
			$response = new stdClass;
			$response->error     = "UNCAUGHT_EXCEPTION";
			$response->message   = $exception->getMessage();
			$response->exception = json_encode($exception);
			$response->error_log = $sc_error_log;
			$response->last_sql_query = $sc_last_sql_query;
			$response->backtrace = debug_backtrace(2,5);
			echo json_encode($response);
			die;
	}
	
	function attachCSErrLog(&$obj){
		global $sc_error_log, $manager;
		if(!isset($sc_error_log))
			$sc_error_log = array();
		$obj->sc_error_log      = $sc_error_log;
		
		if($obj){
			if(isset($obj->errors)){
				$obj->sc_error_log = array_merge($obj->sc_error_log,$obj->errors);	
			}
		}
		
		//OVDE
		if(!empty($obj->sc_error_log) || sc_read_sanitized_get_parm("SC_DEBUG")){
			$obj->sc_query_log = $manager->QUERIES;
		}
		
		if(!sc_read_sanitized_get_parm("SC_DEBUG",null)){
			if(isset($obj->sc_error_log)){
				if(isset($obj->sc_error_log[E_DEPRECATED])){
					unset($obj->sc_error_log[E_DEPRECATED]);
				}
				if(isset($obj->sc_error_log[E_USER_DEPRECATED])){
					unset($obj->sc_error_log[E_USER_DEPRECATED]);
				}
				if(isset($obj->sc_error_log[16384])){
					unset($obj->sc_error_log[16384]);
				}
				if(empty($obj->sc_error_log)){
					unset($obj->sc_error_log);
				}
			}
		}
		
	}
	
	set_error_handler("sc_error_handler",E_ALL);
	set_exception_handler("sc_uncaught_exception_handler");
	
	//error_reporting(E_ALL ^ E_DEPRECATED);
	//ini_set("display_errors","off");
	
	if(isset($_SERVER['HTTP_ACCEPT_ENCODING'])){
		if(stripos($_SERVER['HTTP_ACCEPT_ENCODING'],'gzip') !== false){
			if(ob_start("ob_gzhandler")){
				header("Content-Encoding:gzip");
			}
		}
	}
	
	//if(isset($_SERVER['HTTP_ORIGIN']))
	// header('Access-Control-Allow-Origin: ' . $_SERVER['HTTP_ORIGIN']); 
	//else
	header('Access-Control-Allow-Origin: *');

 
	header('Content-Type: text/json');
	
	if(sc_read_sanitized_request_parm("scp_op")){
		global $sc_luid;
		
		if(sc_read_sanitized_request_parm("luid")){
			$sc_luid = sc_read_sanitized_request_parm("luid");
		}else if(isset($_SERVER["luid"])){
			$sc_luid = $_SERVER["luid"];
		}
		
		$json  = file_get_contents('php://input');
		
		if($json){
	    	$_data = json_decode($json);
			if($_data){
				if(isset($_data->luid)){
					$sc_luid = $_data->luid;
				}
			}
		}else
			$_data = null;
			
		if(!$_data){
			$_data = new stdClass;
		}	
		
		if(!$sc_luid){
			header('HTTP/1.0 403 Forbidden');
			echo '403 Forbidden NLUID';
			die;
		}
		
		$sc_token = sc_user_token($sc_luid);
		
		if(!$sc_token){
			header('HTTP/1.0 403 Forbidden');
			echo '403 Forbidden NTOK';
			die;
		}
		
		$request_token = null;
		if(sc_read_sanitized_request_parm("sctoken")){
			$request_token = sc_read_sanitized_request_parm("sctoken");
		}else if(isset($_SERVER["sctoken"])){
			$request_token = $_SERVER["sctoken"];
		}
		
		if($sc_token != $request_token || !$request_token){
			header('HTTP/1.0 403 Forbidden');
			echo '403 Forbidden / invalid token';
			die;
		}
		
		if(sc_read_sanitized_request_parm("scp_op") == "sc_connector_update"){
			if(isset($_data->updated_script_version)){
				try{
					$cnt = @file_get_contents("https://sellingcommander.com/connectors/virtuemart/{$_data->updated_script_version}/scmanager.update");
					if($cnt){
						$core_file_update = array(
							"updated" => file_put_contents(__DIR__ . DIRECTORY_SEPARATOR . "scmanager.php", $cnt),
							"version" => $_data->updated_script_version
						);
						
						if($core_file_update["updated"] > 0){
							$cntr = @file_get_contents("https://sellingcommander.com/connectors/virtuemart/{$_data->updated_script_version}/sellingcommanderconnector.update");
							if($cntr){
								$core_file_update["updaterouterfile"] = @file_put_contents(__DIR__ . DIRECTORY_SEPARATOR . "sellingcommanderconnector.php", $cntr);
							}
						}
						
						return json_encode($core_file_update);
					}else{
						echo json_encode(array(
							"use_site_update_system" =>  true
						));
					}
				}catch(Throwable $ex){
					echo json_encode(array(
						"use_site_update_system" =>  true,
						"error" => $ex->getMessage()
					));
				}
			}else{
				echo json_encode(array(
					"use_site_update_system" =>  true
				));
			}
			die;
		}
		
		require_once( "scmanager.php" ) ;
		global $manager;
		
		$datascope = sc_read_sanitized_request_parm("datascope", null);
		$manager = new SCManager($datascope);
		
		$scp_op = sc_read_sanitized_request_parm("scp_op");
		
		if($scp_op == "sc_getproducts"){
			
			$page  = sc_read_sanitized_request_parm("page",1);
			$limit = sc_read_sanitized_request_parm("limit",500);
			
			$for_orders = sc_read_sanitized_request_parm("for_order",false);
			if($for_orders){
				$for_orders = intval($for_orders);
			}
			
			$res = $manager->getProducts($page,$limit,$_data,$for_orders);
			$res->execution_time_ms = getCurrentTS() - $ts;
			
			if(sc_read_sanitized_request_parm("include_events_log")){
				$res->events_after = sc_read_sanitized_request_parm("include_events_log");
				$res->events_type  = sc_read_sanitized_request_parm("events_type","PRODUCT");
				$err = array();
				$manager->get_event_log($res,$err);
			}
			
			attachCSErrLog($res);
			echo json_encode($res);
		}else if($scp_op == "sc_getproduct"){
			if(!sc_read_sanitized_request_parm("id")){
				echo '{"error": 400}';
			}else{
				$res = new stdClass;
				$res->product = $manager->getProduct(sc_read_sanitized_request_parm("id"),true);
				$res->execution_time_ms = getCurrentTS() - $ts;
				attachCSErrLog($res);
				echo json_encode($res);
			}
		}else if($scp_op == "sc_getshoppers"){
			
			$page  = sc_read_sanitized_request_parm("page",1);
			$limit = sc_read_sanitized_request_parm("limit",500);
			
			$res = $manager->getShoppers($page,$limit,$_data);
			$res->execution_time_ms = getCurrentTS() - $ts;
			attachCSErrLog($res);
			echo json_encode($res);
		}else if($scp_op == "sc_getorders"){
			
			$page  = sc_read_sanitized_request_parm("page",1);
			$limit = sc_read_sanitized_request_parm("limit",500);
			
			$from_date = sc_read_sanitized_request_parm("from_date");
			$to_date   = sc_read_sanitized_request_parm("to_date");
			
			if(!$from_date)
				$from_date = date('Y-m-d',strtotime("-364 day"));
			
			if(!$to_date)
				$to_date   = date('Y-m-d');
			
			$res = $manager->getOrders($from_date,$to_date,$page,$limit,$_data);
			$res->execution_time_ms = getCurrentTS() - $ts;
			
			if(sc_read_sanitized_request_parm("include_events_log")){
				$res->events_after = sc_read_sanitized_request_parm("include_events_log");
				$res->events_type  = sc_read_sanitized_request_parm("events_type","ORDER");
				$err = array();
				$manager->get_event_log($res, $err );
			}
			
			attachCSErrLog($res);
			echo json_encode($res);
			
		}else if($scp_op == "sc_getorder"){
			if(!sc_read_sanitized_request_parm("id")){
				echo '{"error": 400}';
			}else{
				$res = new stdClass;
				$order = $manager->getOrder(sc_read_sanitized_request_parm("id"));
				$res->order = $order;
				$res->execution_time_ms = getCurrentTS() - $ts;
				attachCSErrLog($res);
				echo json_encode($res);
			}
		}else if($scp_op == "sc_getfullorder"){
			if(!sc_read_sanitized_request_parm("id")){
				echo '{"error": 400}';
			}else{
				$res = new stdClass;
				$order = $manager->getOrder(sc_read_sanitized_request_parm("id"), true);
				$res->order = $order;
				$res->execution_time_ms = getCurrentTS() - $ts;
				attachCSErrLog($res);
				if(sc_read_sanitized_request_parm("report")){
					require("render_report.php");
				}
				echo json_encode($res);
			}
		}else if($scp_op == "sc_getshopper"){
			if(!sc_read_sanitized_request_parm("id")){
				echo '{"error": 400}';
			}else{
				$res = new stdClass;
				$shopper = $manager->getShopper(sc_read_sanitized_request_parm("id"));
				$res->shopper = $shopper;
				$res->execution_time_ms = getCurrentTS() - $ts;
				attachCSErrLog($res);
				echo json_encode($res);
			}
		}else if($scp_op == "sc_getfullshopper"){
			if(!sc_read_sanitized_request_parm("id")){
				echo '{"error": 400}';
			}else{
				$res = new stdClass;
				
				$shopper = $manager->getShopper(sc_read_sanitized_request_parm("id"),true);
				$res->shopper = $shopper;
				
				if(!$res->shopper){
					//IF REGISTRATION
					$res->shopper = json_decode(json_encode(JFactory::getUser(sc_read_sanitized_request_parm("id"))));
				}
				
				$res->execution_time_ms = getCurrentTS() - $ts;
				attachCSErrLog($res);
				if(sc_read_sanitized_request_parm("report")){
					require("render_report.php");
				}
				echo json_encode($res);
			}
		}else if($scp_op == "sc_getproducts_media"){
			
			$page  = sc_read_sanitized_request_parm("page",1);
			$limit = sc_read_sanitized_request_parm("limit",500);
			
			$res = $manager->getProductsMedia($page,$limit,$_data);
			$res->execution_time_ms = getCurrentTS() - $ts;
			attachCSErrLog($res);
			echo json_encode($res);
			
		}else if($scp_op == "sc_getproductaux"){
			
			$res = $manager->getProductAux($_data);
			$res->execution_time_ms = getCurrentTS() - $ts;
			attachCSErrLog($res);
			echo json_encode($res);
			
		}else if($scp_op == "sc_getorderaux"){
			
			$res = $manager->getOrderAux($_data);
			$res->execution_time_ms = getCurrentTS() - $ts;
			attachCSErrLog($res);
			echo json_encode($res);
			
		}else if($scp_op == "sc_getsiteinfo"){
			
			$for_orders = sc_read_sanitized_request_parm("for_order", false);
			if($for_orders){
				$for_orders = intval($for_orders);
			}
			
			$res = $manager->getSiteInfo($for_orders);
			$res->execution_time_ms = getCurrentTS() - $ts;
			attachCSErrLog($res);
			echo json_encode($res);
			
		}else if($scp_op == "sc_forwardsettings"){
			$res = new stdClass;
			
			if($_data){
				if(isset($_data->settings) && sc_read_sanitized_request_parm("datascope")){
					$save_res = $manager->saveSettings($_data->settings, sc_read_sanitized_request_parm("datascope"));
					if($save_res === true){
						$res->result   = "OK";
						$res->message  = "Site settings saved";
						$res->settings = $manager->settings;
						$res->settings_saved = 1;
					}else{
						$res->result  = "Error";
						$res->message = $save_res;
					}
				}else{
					$res->result  = "Error";
					$res->message = "INSUFFICIENT DATA";
				}
			}
			
			$res->execution_time_ms = getCurrentTS() - $ts;
			attachCSErrLog($res);
			echo json_encode($res);
		}else if($scp_op == "sc_update_product"){
			
			if(sc_read_sanitized_request_parm("SCMDEBUG")){
				$manager->setDebug(true);
			}
		    
			$updates_additional_ids = array();
			
			global $scerr;
			$scerr = array();
			
			if(isset($_data->products)){
				foreach($_data->products as $pid => $pdata){
					$_data->products->{$pid} = $manager->updateProduct($pdata,$updates_additional_ids);
				}
			}
				
			foreach($updates_additional_ids as $pid => $val){
				if(!$val)
					continue;
				else if($val === true)
					$p = $manager->getProduct($pid, true);
				else
					$p = $val;
				
				if($p){
					$p->is_dependent_update = true;
					$_data->products->{$pid} = $p;
				}
			}
			
			global $added_aux;
			if(isset($added_aux)){
				$_data->added_aux = $added_aux;
			}
			
			if(!empty($scerr)){
				$_data->errors = $scerr;
			}
			
			$_data->execution_time_ms = getCurrentTS() - $ts;
			attachCSErrLog($_data);
			echo json_encode($_data);
			
		} else if($scp_op){
		
			$method_name = substr($scp_op,3);
			if(method_exists($manager,$method_name)){
				
				$err = array();
				
				
				$res = $manager->{$method_name}($_data, $err);
				
				if(!isset($res))
					$res = new stdClass;
				
				if(!empty($err)){
					$res->errors = $err;
				}
				
				$res->execution_time_ms = getCurrentTS() - $ts;
				
				attachCSErrLog($res);
				echo json_encode($res);
				
			}else{
				header('HTTP/1.0 404 Method not found');
				echo "404 Method not found";
			}
		}
		die;
	}else{
		header('HTTP/1.0 403 Forbidden');
		echo "403 Forbidden NOP";
	}
}else{
	header('HTTP/1.0 403 Forbidden');
	echo '403 Forbidden NTG';
}
exit;
die;
?>